(*
 * (c) Andreas Rossberg 1999-2007
 *
 * Standard ML state
 *
 * Definition, Section 6.3
 *
 * Notes:
 *   - Memory gets represented by references. This avoids expanding out all
 *     occurances of the state convention in the inference rules.
 *   - Since exception names are generated by stamps we do not really need the
 *     exception name set. We maintain it anyway.
 *)

signature STATE =
sig
    (* Import *)

    type Addr		= DynamicObjectsCore.Addr
    type ExName		= DynamicObjectsCore.ExName
    type Val		= DynamicObjectsCore.Val
    type State		= DynamicObjectsCore.State


    (* Operations *)

    val insertAddr :	State * Addr * Val -> State
    val insertExName :	State * ExName     -> State

    val findAddr :	State * Addr -> Val option
end;
